SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

Object subclass: #Cart
	instanceVariableNames: 'empty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/27/2013 21:46'!
addBook: aBook
	empty := false.
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/27/2013 21:22'!
contains: aBook
	^true! !

!Cart methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/27/2013 21:17'!
initialize 
	empty := true.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/27/2013 21:16'!
isEmpty
	^empty.! !

Object subclass: #Catalogue
	instanceVariableNames: 'catalogue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Catalogue methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/27/2013 21:31'!
initialize
	catalogue := Set new.! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/27/2013 21:11'!
cart
	^Cart new.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/27/2013 21:03'!
test01newCartMustBeEmptyOnCreation

	self assert: self cart isEmpty.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/27/2013 21:19'!
test02cartMustNotBeEmptyAfterAddingABook
	
	|aCart|
	
	aCart := self cart.
	aCart addBook: 'Lord of the rings'.
	self deny: aCart isEmpty.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/27/2013 21:45'!
test03cannotAddBookIfItIsNotPresentInCatalogue
	
	|aCart aBook aCatalogue|
	
	aCart := self cart.
	aBook := 'Lord of the rings'.
	aCatalogue := Catalogue new.

	aCatalogue contains:  aBook.	
	
	self should: [ aCart addBook: aBook. ] raise: Error withExceptionDo: [ :anError | self assert: anError  ].

	self assert: (aCart contains: aBook) .! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/27/2013 21:35'!
test04bookMustBeInCartAfterAddition
	
	|aCart|
	
	aCart := self cart.
	aCart addBook: 'Lord of the rings'.

	self assert: (aCart contains: 'Lord of the rings').! !
